<?php
/***********************************************************************
  N-13 News is a free news publishing system
  Copyright (C) 2009 Chris Watt
  
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.If not, see <http://www.gnu.org/licenses/>.
***********************************************************************/

include 'db.php';
include 'config.php';
$feed = slash2($_GET['feed']);
$rssexists = DataAccess::fetch("SELECT name,location,title,description,encoding,language,amounttodisplay,rsscode,nocats,feedid FROM $newsfeeds WHERE name = ?", $feed);
if(!$rssexists){
    die("RSS Feed doesn't exist.");    
}
$all = $rssexists['0'];
$rsslanguage = $all['language'];
$rssdescription = $all['description'];
$rssencoding = $all['encoding'];
$rsstitle = $all['title'];
$rssamount = slash2($all['amounttodisplay']);
$rssdisplay = $all['display'];
$newslocation = $all['location'];
$rsscode = $all['rsscode'];
$feedid = $all['feedid'];
$nocats = $all['nocats'];
if($rssamount == "0"){
    $rssamount = '999999';   
}

if(!$newslocation){
	die("RSS Feed not configured. Please login to the admin area goto <b>Options</b> > <b>RSS Feeds</b>");
}
header("Content-type: text/xml");
$feedlocation = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
echo '<?xml version="1.0" encoding="'.$rssencoding.'" ?>';
?>
<rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">
 <channel>
 <atom:link href="<?php echo $feedlocation; ?>" rel="self" type="application/rss+xml" />
   <title><?php echo $rsstitle; ?></title>
   <link><?php echo $newslocation; ?></link>
   <language><?php echo $rsslanguage; ?></language>
   <description><?php echo $rssdescription; ?></description>
   <!-- RSS 2.0 file generated by N-13 News -->
   <generator>N-13 News</generator>
<?php
	$prefix = DataAccess::fetch("SELECT furlprefix FROM $newsoptions WHERE 1");
	$prefix = $prefix['0']['furlprefix'];
    //select all categories this rss feed has been assigned
    //then select all news posts assigned to those same cats
    //if nocats = 1 also select all posts not assigned to cats
    $sql = "SELECT title,story,shortstory,author,origauthor,ip,timestamp,catid,allowcomments,short,approved,viewcount,rating,archivedate,neverarchive,archived,id, 
	$newsusers.user AS authorname, 
	$newsusers.avatar AS authoravatar, 
	(SELECT COUNT(id) FROM $newscomments WHERE $newscomments.pid = $newstable.id) AS comments
	FROM $newstable INNER JOIN $newsusers ON $newstable.author = $newsusers.uid WHERE id IN (";
        if($nocats == "1"){
            $sql .= "SELECT id AS storyid FROM $newstable WHERE id NOT IN (SELECT storyid FROM $newsgroupcats WHERE type = 'news') UNION ";
        }                
    $sql .= "SELECT storyid FROM $newsgroupcats WHERE type = 'news' AND catid IN (SELECT catid FROM $newsgroupcats WHERE type = 'rss' AND storyid = ?) ) AND archived = '0' ORDER BY timestamp DESC LIMIT 0, $rssamount";
    $newsstories = DataAccess::fetch($sql, $feedid);
    foreach($newsstories AS $row){

		if($friendly){
			$fullurl = $newslocation . $prefix . $row[id] . "/0/" . makefriendly($row[title]);
		}else{
			$fullurl = $newslocation . '?id=' . $row[id]; 
		}

		$sql3 = "SELECT $newscats.name AS catname FROM $newsgroupcats INNER JOIN $newscats ON $newsgroupcats.catid = $newscats.id WHERE storyid = '?' AND type = 'news' ORDER BY $newscats.name ASC";
		$cats = DataAccess::fetch($sql, $row['id']);
        foreach($cats AS $row3){
			$categories .= $row3['catname'] . $catdelimiter;
		}
		$categories = substr($categories,0,strlen($categories) - strlen($catdelimiter));

		$rsstemplate = $rsscode;
		$rsstemplate = str_replace("{categories}",$categories,$rsstemplate);	
		$rsstemplate = str_replace("{title}",displayhtml($row['title']),$rsstemplate);
		$rsstemplate = str_replace("{url}",$fullurl,$rsstemplate);
		$rsstemplate = str_replace("{shortstory}",bbcode($row['shortstory'],$newssmilies,0),$rsstemplate);
		$rsstemplate = str_replace("{story}",bbcode($row['story'],$newssmilies,0),$rsstemplate);
		$rsstemplate = str_replace("{date}",date("D, j M Y h:i:s",$row['timestamp']),$rsstemplate);
		$rsstemplate = str_replace("{timezone}",$timezone,$rsstemplate);
		$rsstemplate = str_replace("{timestamp}",$row['timestamp'],$rsstemplate);
		$rsstemplate = str_replace("{author}",$row['authorname'],$rsstemplate);
		$rsstemplate = str_replace("{avatar}","<img src=\"" . $row['authoravatar'] . "\" />",$rsstemplate);
		$rsstemplate = str_replace("{id}",$row['id'],$rsstemplate);
		$rsstemplate = str_replace("{comments}",$row['comments'],$rsstemplate);
		echo $rsstemplate;
        unset($categories);    
    }
?>
</channel>
</rss>